--- src/sieve-cmu.c.orig	2008-05-16 15:09:09.000000000 +0200
+++ src/sieve-cmu.c	2008-07-21 12:19:10.000000000 +0200
@@ -898,14 +898,14 @@
 dovecot_sieve_compile(script_data_t *sdata, const char *script_path,
 		      const char *compiled_path)
 {
-	struct stat st, st2;
+	struct stat st, st2, stlnk;
 	sieve_script_t *script;
 	bytecode_info_t *bc;
 	const char *temp_path;
 	FILE *f;
 	int fd, ret;
 
-	if (stat(script_path, &st) < 0) {
+	if (lstat(script_path, &st) < 0) {
 		if (errno == ENOENT) {
 			if (getenv("DEBUG") != NULL) {
 				i_info("cmusieve: Script not found: %s",
@@ -913,20 +913,28 @@
 			}
 			return 0;
 		}
-		i_error("stat(%s) failed: %m", script_path);
+		i_error("lstat(%s) failed: %m", script_path);
 		return -1;
 	}
 	if (S_ISDIR(st.st_mode)) {
 		i_error("%s should be a file, not a directory", script_path);
 		return -1;
 	}
+	/* in case of symbolic link compare linked files date, too */
+	if (S_ISLNK(st.st_mode)) {
+		if (stat(script_path, &stlnk) < 0) {
+			i_error("stat(%s) failed: %m", script_path);
+			return -1;
+		}
+	}
 	if (stat(compiled_path, &st2) < 0) {
 		if (errno != ENOENT) {
 			i_error("stat(%s) failed: %m", script_path);
 			return -1;
 		}
 	} else {
-		if (st.st_mtime <= st2.st_mtime)
+		if (st.st_mtime <= st2.st_mtime && 
+				(!S_ISLNK(st.st_mode) || stlnk.st_mtime <= st2.st_mtime))
 			return 1;
 	}
 
